//
package com.bearingpoint.acs;
//
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
//
import junit.framework.*;



public class TxMisc extends TestCase
{
	private String msFile = "C:\\vss\\acs\\build\\bldvernum.txt"; 

    public void test_replaceNonNumeric()
    {
      System.out.println("My test running");
      Assert.assertEquals("01234656789", "01234656789");
      
      String mine = createUniqueBuildNumber( "1.1.1." );
      System.out.println("Done, ver=" + mine );
    }
    
    // Fetches and sets the compile unique number 
    public  String createUniqueBuildNumber( String psTopVersion ) 
    {
 	  int buildNumber = 0;
    
 	   try
 	   {
 	     // Get build number from file, update and save to file
 	     buildNumber = getNumberFromFile( msFile );
 	     setBuildNumberToFile( msFile, buildNumber + 1 );
 	
 	     System.out.println( "*** ACSBuildNumber plugin, creating build Number, version=" + psTopVersion + buildNumber );
 	   }
 	   catch( Exception ex )
 	   {
 		   System.out.println( "*** ACSBuildNumber plugin, error=" + ex );
 	   }
 	   
 	   // Return new number to caller 
 	   return psTopVersion + buildNumber;
    }
    
    
    // Read text from file 
    static public int getNumberFromFile( String psFile ) 
    {
 	    //
 	    File readFile = new File( psFile );
 	    StringBuilder contents = new StringBuilder();
 	    
 	    try 
 	    {
 	      // use buffering, reading one line at a time
 	      // FileReader always assumes default encoding is OK!
 	      BufferedReader input =  new BufferedReader(new FileReader( readFile));
 	      try 
 	      {
 	        String line = null; 
 	        while (( line = input.readLine()) != null)
 	          contents.append(line);
 	      }
 	      finally 
 	      {
 	        input.close();
 	      }
 	    }
 	    catch (IOException ex)
 	    {
 	      ex.printStackTrace();
 	    }

 	    System.out.println( "*** ACSBuildNumber plugin, read compile number from file, ver=" + contents.toString() );
 	    return Integer.parseInt( contents.toString() );
 	  }

    	  // Write text to file 	
 	  static public void setBuildNumberToFile(String psFile, int piNumber)
 	                                 throws FileNotFoundException, IOException 
       {

 	    //use buffering
 		File writeFile = new File( psFile );
 	    Writer output = new BufferedWriter(new FileWriter(writeFile));
 	    try 
 	    {
 	      //FileWriter always assumes default encoding is OK!
 	      output.write( "" + piNumber );
 	    }
 	    finally 
 	    {
 	      output.close();
 	    }
 	    
 	    System.out.println( "*** ACSBuildNumber plugin, saved compile number to file, ver=" + piNumber );
 	  }

 	  
    public static Test suite()
   { 
      TestSuite suite = new TestSuite();
      // Add more tests here
      suite.addTestSuite(com.bearingpoint.acs.TxMisc.class);

      return suite;
    }

  /**
  * Runs the test suite using the textual runner.
  */
  public static void main(String[] args)
  {
      junit.textui.TestRunner.run(suite());
      System.exit(0);
  }

}  // EOC
